Index: kernel/generic/include/proc/task.h
===================================================================
--- kernel/generic/include/proc/task.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/proc/task.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -1,3 +1,3 @@
-/*
+/*3D
  * Copyright (c) 2001-2004 Jakub Jermar
  * All rights reserved.
@@ -36,16 +36,63 @@
 #define KERN_TASK_H_
 
-#include <typedefs.h>
 #include <synch/spinlock.h>
 #include <synch/mutex.h>
+#include <synch/rwlock.h>
 #include <synch/futex.h>
 #include <adt/btree.h>
 #include <adt/list.h>
-#include <ipc/ipc.h>
 #include <security/cap.h>
 #include <arch/proc/task.h>
+#include <arch/proc/thread.h>
+#include <arch/context.h>
+#include <arch/fpu_context.h>
+#include <arch/cpu.h>
+#include <mm/tlb.h>
+#include <proc/scheduler.h>
+
+#define IPC_MAX_PHONES  16
+#define THREAD_NAME_BUFLEN	20
+
+struct answerbox;
+struct task;
+struct thread;
+
+typedef enum {
+	IPC_PHONE_FREE = 0,     /**< Phone is free and can be allocated */
+	IPC_PHONE_CONNECTING,   /**< Phone is connecting somewhere */
+	IPC_PHONE_CONNECTED,    /**< Phone is connected */
+	IPC_PHONE_HUNGUP,  	/**< Phone is hung up, waiting for answers to come */
+	IPC_PHONE_SLAMMED       /**< Phone was hungup from server */
+} ipc_phone_state_t;
+
+/** Structure identifying phone (in TASK structure) */
+typedef struct {
+	SPINLOCK_DECLARE(lock);
+	link_t link;
+	struct answerbox *callee;
+	ipc_phone_state_t state;
+	atomic_t active_calls;
+} phone_t;
+
+typedef struct answerbox {
+	SPINLOCK_DECLARE(lock);
+
+	struct task *task;
+
+	waitq_t wq;
+
+	link_t connected_phones;	/**< Phones connected to this answerbox */
+	link_t calls;			/**< Received calls */
+	link_t dispatched_calls;	/* Should be hash table in the future */
+
+	link_t answers;			/**< Answered calls */
+
+	SPINLOCK_DECLARE(irq_lock);
+	link_t irq_notifs;       	/**< Notifications from IRQ handlers */
+	link_t irq_head;		/**< IRQs with notifications to this answerbox. */
+} answerbox_t;
 
 /** Task structure. */
-struct task {
+typedef struct task {
 	/** Task lock.
 	 *
@@ -55,5 +102,5 @@
 	
 	char *name;
-	thread_t *main_thread;	/**< Pointer to the main thread. */
+	struct thread *main_thread;	/**< Pointer to the main thread. */
 	link_t th_head;		/**< List of threads contained in this task. */
 	as_t *as;		/**< Address space. */
@@ -85,5 +132,162 @@
 	
 	uint64_t cycles;	/**< Accumulated accounting. */
-};
+} task_t;
+
+/** CPU structure.
+ *
+ * There is one structure like this for every processor.
+ */
+typedef struct {
+	SPINLOCK_DECLARE(lock);
+
+	tlb_shootdown_msg_t tlb_messages[TLB_MESSAGE_QUEUE_LEN];
+	count_t tlb_messages_count;
+	
+	context_t saved_context;
+
+	atomic_t nrdy;
+	runq_t rq[RQ_COUNT];
+	volatile count_t needs_relink;
+
+	SPINLOCK_DECLARE(timeoutlock);
+	link_t timeout_active_head;
+
+	count_t missed_clock_ticks;	/**< When system clock loses a tick, it is recorded here
+					     so that clock() can react. This variable is
+					     CPU-local and can be only accessed when interrupts
+					     are disabled. */
+
+	/**
+	 * Processor ID assigned by kernel.
+	 */
+	int id;
+	
+	int active;
+	int tlb_active;
+
+	uint16_t frequency_mhz;
+	uint32_t delay_loop_const;
+
+	cpu_arch_t arch;
+
+	struct thread *fpu_owner;
+	
+	/**
+	 * Stack used by scheduler when there is no running thread.
+	 */
+	uint8_t *stack;
+} cpu_t;
+
+typedef void (* timeout_handler_t)(void *arg);
+
+typedef struct {
+	SPINLOCK_DECLARE(lock);
+
+	link_t link;			/**< Link to the list of active timeouts on THE->cpu */
+	
+	uint64_t ticks;			/**< Timeout will be activated in this amount of clock() ticks. */
+
+	timeout_handler_t handler;	/**< Function that will be called on timeout activation. */
+	void *arg;			/**< Argument to be passed to handler() function. */
+	
+	cpu_t *cpu;			/**< On which processor is this timeout registered. */
+} timeout_t;
+
+/** Thread states. */
+typedef enum {
+	Invalid,	/**< It is an error, if thread is found in this state. */
+	Running,	/**< State of a thread that is currently executing on some CPU. */
+	Sleeping,	/**< Thread in this state is waiting for an event. */
+	Ready,		/**< State of threads in a run queue. */
+	Entering,	/**< Threads are in this state before they are first readied. */
+	Exiting,	/**< After a thread calls thread_exit(), it is put into Exiting state. */
+	Undead		/**< Threads that were not detached but exited are in the Undead state. */
+} state_t;
+
+/** Join types. */
+typedef enum {
+	None,
+	TaskClnp,	/**< The thread will be joined by ktaskclnp thread. */
+	TaskGC		/**< The thread will be joined by ktaskgc thread. */
+} thread_join_type_t;
+
+/** Thread structure. There is one per thread. */
+typedef struct thread {
+	link_t rq_link;				/**< Run queue link. */
+	link_t wq_link;				/**< Wait queue link. */
+	link_t th_link;				/**< Links to threads within containing task. */
+	
+	/** Lock protecting thread structure.
+	 *
+	 * Protects the whole thread structure except list links above.
+	 */
+	SPINLOCK_DECLARE(lock);
+
+	char name[THREAD_NAME_BUFLEN];
+
+	void (* thread_code)(void *);		/**< Function implementing the thread. */
+	void *thread_arg;			/**< Argument passed to thread_code() function. */
+
+	/** From here, the stored context is restored when the thread is scheduled. */
+	context_t saved_context;
+	/** From here, the stored timeout context is restored when sleep times out. */
+	context_t sleep_timeout_context;
+	/** From here, the stored interruption context is restored when sleep is interrupted. */
+	context_t sleep_interruption_context;
+
+	bool sleep_interruptible;		/**< If true, the thread can be interrupted from sleep. */
+	waitq_t *sleep_queue;			/**< Wait queue in which this thread sleeps. */
+	timeout_t sleep_timeout;		/**< Timeout used for timeoutable sleeping.  */
+	volatile int timeout_pending;		/**< Flag signalling sleep timeout in progress. */
+
+	/** True if this thread is executing copy_from_uspace(). False otherwise. */
+	bool in_copy_from_uspace;
+	/** True if this thread is executing copy_to_uspace(). False otherwise. */
+	bool in_copy_to_uspace;
+	
+	/**
+	 * If true, the thread will not go to sleep at all and will
+	 * call thread_exit() before returning to userspace.
+	 */
+	bool interrupted;			
+	
+	thread_join_type_t	join_type;	/**< Who joinins the thread. */
+	bool detached;				/**< If true, thread_join_timeout() cannot be used on this thread. */
+	waitq_t join_wq;			/**< Waitq for thread_join_timeout(). */
+
+	fpu_context_t *saved_fpu_context;
+	int fpu_context_exists;
+
+	/*
+	 * Defined only if thread doesn't run.
+	 * It means that fpu context is in CPU that last time executes this thread.
+	 * This disables migration.
+	 */
+	int fpu_context_engaged;
+
+	rwlock_type_t rwlock_holder_type;
+
+	void (* call_me)(void *);		/**< Funtion to be called in scheduler before the thread is put asleep. */
+	void *call_me_with;			/**< Argument passed to call_me(). */
+
+	state_t state;				/**< Thread's state. */
+	int flags;				/**< Thread's flags. */
+	
+	cpu_t *cpu;				/**< Thread's CPU. */
+	task_t *task;				/**< Containing task. */
+
+	uint64_t ticks;				/**< Ticks before preemption. */
+	
+	uint64_t cycles;			/**< Thread accounting. */
+	uint64_t last_cycle;		/**< Last sampled cycle. */
+	bool uncounted;				/**< Thread doesn't affect accumulated accounting. */
+
+	int priority;				/**< Thread's priority. Implemented as index to CPU->rq */
+	uint32_t tid;				/**< Thread ID. */
+	
+	thread_arch_t arch;			/**< Architecture-specific data. */
+
+	uint8_t *kstack;			/**< Thread's kernel stack. */
+} thread_t;
 
 extern spinlock_t tasks_lock;
@@ -98,4 +302,7 @@
 extern uint64_t task_get_accounting(task_t *t);
 
+extern void cap_set(task_t *t, cap_t caps);
+extern cap_t cap_get(task_t *t);
+
 
 #ifndef task_create_arch
Index: kernel/generic/include/proc/thread.h
===================================================================
--- kernel/generic/include/proc/thread.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/proc/thread.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,126 +36,22 @@
 #define KERN_THREAD_H_
 
-#include <arch/proc/thread.h>
-#include <synch/spinlock.h>
-#include <arch/context.h>
-#include <fpu_context.h>
-#include <arch/types.h>
-#include <typedefs.h>
-#include <time/timeout.h>
+#include <synch/waitq.h>
+#include <proc/task.h>
+#include <cpu.h>
 #include <synch/rwlock.h>
-#include <synch/synch.h>
-#include <config.h>
 #include <adt/btree.h>
-#include <adt/list.h>
 #include <mm/slab.h>
+#include <arch/cpu.h>
+#include <mm/tlb.h>
 #include <proc/uarg.h>
 
 #define THREAD_STACK_SIZE	STACK_SIZE
 
-/** Thread states. */
-typedef enum {
-	Invalid,	/**< It is an error, if thread is found in this state. */
-	Running,	/**< State of a thread that is currently executing on some CPU. */
-	Sleeping,	/**< Thread in this state is waiting for an event. */
-	Ready,		/**< State of threads in a run queue. */
-	Entering,	/**< Threads are in this state before they are first readied. */
-	Exiting,	/**< After a thread calls thread_exit(), it is put into Exiting state. */
-	Undead		/**< Threads that were not detached but exited are in the Undead state. */
-} state_t;
-
 extern char *thread_states[];
 
-/** Join types. */
-typedef enum {
-	None,
-	TaskClnp,	/**< The thread will be joined by ktaskclnp thread. */
-	TaskGC		/**< The thread will be joined by ktaskgc thread. */
-} thread_join_type_t;
-
 /* Thread flags */
-#define THREAD_FLAG_WIRED	(1<<0)	/**< Thread cannot be migrated to another CPU. */
-#define THREAD_FLAG_STOLEN	(1<<1)	/**< Thread was migrated to another CPU and has not run yet. */
-#define THREAD_FLAG_USPACE	(1<<2)	/**< Thread executes in userspace. */
-
-#define THREAD_NAME_BUFLEN	20
-
-/** Thread structure. There is one per thread. */
-struct thread {
-	link_t rq_link;				/**< Run queue link. */
-	link_t wq_link;				/**< Wait queue link. */
-	link_t th_link;				/**< Links to threads within containing task. */
-	
-	/** Lock protecting thread structure.
-	 *
-	 * Protects the whole thread structure except list links above.
-	 */
-	SPINLOCK_DECLARE(lock);
-
-	char name[THREAD_NAME_BUFLEN];
-
-	void (* thread_code)(void *);		/**< Function implementing the thread. */
-	void *thread_arg;			/**< Argument passed to thread_code() function. */
-
-	/** From here, the stored context is restored when the thread is scheduled. */
-	context_t saved_context;
-	/** From here, the stored timeout context is restored when sleep times out. */
-	context_t sleep_timeout_context;
-	/** From here, the stored interruption context is restored when sleep is interrupted. */
-	context_t sleep_interruption_context;
-
-	bool sleep_interruptible;		/**< If true, the thread can be interrupted from sleep. */
-	waitq_t *sleep_queue;			/**< Wait queue in which this thread sleeps. */
-	timeout_t sleep_timeout;		/**< Timeout used for timeoutable sleeping.  */
-	volatile int timeout_pending;		/**< Flag signalling sleep timeout in progress. */
-
-	/** True if this thread is executing copy_from_uspace(). False otherwise. */
-	bool in_copy_from_uspace;
-	/** True if this thread is executing copy_to_uspace(). False otherwise. */
-	bool in_copy_to_uspace;
-	
-	/**
-	 * If true, the thread will not go to sleep at all and will
-	 * call thread_exit() before returning to userspace.
-	 */
-	bool interrupted;			
-	
-	thread_join_type_t	join_type;	/**< Who joinins the thread. */
-	bool detached;				/**< If true, thread_join_timeout() cannot be used on this thread. */
-	waitq_t join_wq;			/**< Waitq for thread_join_timeout(). */
-
-	fpu_context_t *saved_fpu_context;
-	int fpu_context_exists;
-
-	/*
-	 * Defined only if thread doesn't run.
-	 * It means that fpu context is in CPU that last time executes this thread.
-	 * This disables migration.
-	 */
-	int fpu_context_engaged;
-
-	rwlock_type_t rwlock_holder_type;
-
-	void (* call_me)(void *);		/**< Funtion to be called in scheduler before the thread is put asleep. */
-	void *call_me_with;			/**< Argument passed to call_me(). */
-
-	state_t state;				/**< Thread's state. */
-	int flags;				/**< Thread's flags. */
-	
-	cpu_t *cpu;				/**< Thread's CPU. */
-	task_t *task;				/**< Containing task. */
-
-	uint64_t ticks;				/**< Ticks before preemption. */
-	
-	uint64_t cycles;			/**< Thread accounting. */
-	uint64_t last_cycle;		/**< Last sampled cycle. */
-	bool uncounted;				/**< Thread doesn't affect accumulated accounting. */
-
-	int priority;				/**< Thread's priority. Implemented as index to CPU->rq */
-	uint32_t tid;				/**< Thread ID. */
-	
-	thread_arch_t arch;			/**< Architecture-specific data. */
-
-	uint8_t *kstack;			/**< Thread's kernel stack. */
-};
+#define THREAD_FLAG_WIRED	(1 << 0)	/**< Thread cannot be migrated to another CPU. */
+#define THREAD_FLAG_STOLEN	(1 << 1)	/**< Thread was migrated to another CPU and has not run yet. */
+#define THREAD_FLAG_USPACE	(1 << 2)	/**< Thread executes in userspace. */
 
 /** Thread list lock.
@@ -196,4 +92,5 @@
 extern void thread_update_accounting(void);
 extern bool thread_exists(thread_t *t);
+extern void thread_interrupt_sleep(thread_t *t);
 
 /* Fpu context slab cache */
Index: kernel/generic/include/security/cap.h
===================================================================
--- kernel/generic/include/security/cap.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/security/cap.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -50,5 +50,4 @@
 #include <syscall/sysarg64.h>
 #include <arch/types.h>
-#include <typedefs.h>
 
 /**
@@ -82,7 +81,4 @@
 typedef uint32_t cap_t;
 
-extern void cap_set(task_t *t, cap_t caps);
-extern cap_t cap_get(task_t *t);
-
 extern unative_t sys_cap_grant(sysarg64_t *uspace_taskid_arg, cap_t caps);
 extern unative_t sys_cap_revoke(sysarg64_t *uspace_taskid_arg, cap_t caps);
Index: kernel/generic/include/synch/futex.h
===================================================================
--- kernel/generic/include/synch/futex.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/synch/futex.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <synch/waitq.h>
 #include <genarch/mm/page_ht.h>
Index: kernel/generic/include/synch/mutex.h
===================================================================
--- kernel/generic/include/synch/mutex.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/synch/mutex.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <synch/semaphore.h>
 #include <synch/synch.h>
Index: kernel/generic/include/synch/rwlock.h
===================================================================
--- kernel/generic/include/synch/rwlock.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/synch/rwlock.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <synch/mutex.h>
 #include <synch/synch.h>
Index: kernel/generic/include/synch/semaphore.h
===================================================================
--- kernel/generic/include/synch/semaphore.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/synch/semaphore.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <synch/waitq.h>
 #include <synch/synch.h>
@@ -46,9 +45,9 @@
 
 #define semaphore_down(s) \
-	_semaphore_down_timeout((s),SYNCH_NO_TIMEOUT,SYNCH_FLAGS_NONE)
+	_semaphore_down_timeout((s), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
 #define semaphore_trydown(s) \
-	_semaphore_down_timeout((s),SYNCH_NO_TIMEOUT,SYNCH_FLAGS_NON_BLOCKING)	
-#define semaphore_down_timeout(s,usec) \
-	_semaphore_down_timeout((s),(usec),SYNCH_FLAGS_NONE)
+	_semaphore_down_timeout((s), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NON_BLOCKING)	
+#define semaphore_down_timeout(s, usec) \
+	_semaphore_down_timeout((s), (usec), SYNCH_FLAGS_NONE)
 
 extern void semaphore_initialize(semaphore_t *s, int val);
Index: kernel/generic/include/synch/spinlock.h
===================================================================
--- kernel/generic/include/synch/spinlock.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/synch/spinlock.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <preemption.h>
 #include <atomic.h>
@@ -98,5 +97,5 @@
 	CS_LEAVE_BARRIER();
 	
-	atomic_set(&sl->val,0);
+	atomic_set(&sl->val, 0);
 	preemption_enable();
 }
@@ -110,5 +109,5 @@
 #define SPINLOCK_INITIALIZE(name)
 
-#define spinlock_initialize(x,name)
+#define spinlock_initialize(x, name)
 #define spinlock_lock(x)		preemption_disable()
 #define spinlock_trylock(x) 		(preemption_disable(), 1)
Index: kernel/generic/include/synch/waitq.h
===================================================================
--- kernel/generic/include/synch/waitq.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/synch/waitq.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 #include <synch/spinlock.h>
 #include <synch/synch.h>
@@ -59,5 +58,5 @@
 
 #define waitq_sleep(wq) \
-	waitq_sleep_timeout((wq),SYNCH_NO_TIMEOUT,SYNCH_FLAGS_NONE)
+	waitq_sleep_timeout((wq), SYNCH_NO_TIMEOUT, SYNCH_FLAGS_NONE)
 
 extern void waitq_initialize(waitq_t *wq);
@@ -68,5 +67,4 @@
 extern void waitq_wakeup(waitq_t *wq, bool all);
 extern void _waitq_wakeup_unsafe(waitq_t *wq, bool all);
-extern void waitq_interrupt_sleep(thread_t *t);
 
 #endif
Index: kernel/generic/include/syscall/copy.h
===================================================================
--- kernel/generic/include/syscall/copy.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/syscall/copy.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,5 +36,5 @@
 #define KERN_COPY_H_
 
-#include <typedefs.h>
+#include <arch/types.h>
 
 /** Label within memcpy_from_uspace() that contains return -1. */
Index: kernel/generic/include/syscall/syscall.h
===================================================================
--- kernel/generic/include/syscall/syscall.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/syscall/syscall.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -72,5 +72,4 @@
 
 #include <arch/types.h>
-#include <typedefs.h>
 
 typedef unative_t (*syshandler_t)();
Index: kernel/generic/include/time/timeout.h
===================================================================
--- kernel/generic/include/time/timeout.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/time/timeout.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,24 +37,7 @@
 
 #include <arch/types.h>
-#include <cpu.h>
-#include <synch/spinlock.h>
-#include <adt/list.h>
+#include <proc/task.h>
 
-#define us2ticks(us)	((uint64_t)(((uint32_t) (us)/(1000000/HZ))))
-
-typedef void (* timeout_handler_t)(void *arg);
-
-typedef struct {
-	SPINLOCK_DECLARE(lock);
-
-	link_t link;			/**< Link to the list of active timeouts on THE->cpu */
-	
-	uint64_t ticks;			/**< Timeout will be activated in this amount of clock() ticks. */
-
-	timeout_handler_t handler;	/**< Function that will be called on timeout activation. */
-	void *arg;			/**< Argument to be passed to handler() function. */
-	
-	cpu_t *cpu;			/**< On which processor is this timeout registered. */
-} timeout_t;
+#define us2ticks(us)	((uint64_t) (((uint32_t) (us) / (1000000 / HZ))))
 
 extern void timeout_init(void);
Index: kernel/generic/include/typedefs.h
===================================================================
--- kernel/generic/include/typedefs.h	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/include/typedefs.h	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -36,44 +36,5 @@
 #define KERN_TYPEDEFS_H_
 
-#define false 0
-#define true 1
-
-typedef short bool;
-
-typedef unsigned long size_t;
-typedef unsigned long count_t;
-typedef unsigned long index_t;
-
-typedef unsigned long long task_id_t;
-typedef unsigned long context_id_t;
-
-typedef struct task task_t;
-typedef struct thread thread_t;
-
-typedef struct as_area as_area_t;
-typedef struct as as_t;
-
-typedef struct link link_t;
-
-typedef struct chardev chardev_t;
-
-typedef enum cmd_arg_type cmd_arg_type_t;
-typedef struct cmd_arg cmd_arg_t;
-typedef struct cmd_info cmd_info_t;
-
-typedef struct istate istate_t;
 typedef void (* function)();
-typedef void (* iroutine)(int n, istate_t *istate);
-
-typedef struct hash_table hash_table_t;
-typedef struct hash_table_operations hash_table_operations_t;
-
-typedef struct btree_node btree_node_t;
-typedef struct btree btree_t;
-
-typedef signed int inr_t;
-typedef signed int devno_t;
-typedef struct irq irq_t;
-typedef struct ipc_notif_cfg ipc_notif_cfg_t;
 
 #endif
Index: kernel/generic/src/adt/bitmap.c
===================================================================
--- kernel/generic/src/adt/bitmap.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/adt/bitmap.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -39,5 +39,4 @@
 
 #include <adt/bitmap.h>
-#include <typedefs.h>
 #include <arch/types.h>
 #include <align.h>
Index: kernel/generic/src/adt/btree.c
===================================================================
--- kernel/generic/src/adt/btree.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/adt/btree.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -52,5 +52,4 @@
 #include <debug.h>
 #include <panic.h>
-#include <typedefs.h>
 #include <print.h>
 
Index: kernel/generic/src/adt/hash_table.c
===================================================================
--- kernel/generic/src/adt/hash_table.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/adt/hash_table.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -40,5 +40,4 @@
 #include <adt/hash_table.h>
 #include <adt/list.h>
-#include <typedefs.h>
 #include <arch/types.h>
 #include <debug.h>
Index: kernel/generic/src/console/cmd.c
===================================================================
--- kernel/generic/src/console/cmd.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/console/cmd.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -46,5 +46,4 @@
 #include <print.h>
 #include <panic.h>
-#include <typedefs.h>
 #include <arch/types.h>
 #include <adt/list.h>
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/console/console.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -39,5 +39,4 @@
 #include <synch/spinlock.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch.h>
 #include <func.h>
Index: kernel/generic/src/console/kconsole.c
===================================================================
--- kernel/generic/src/console/kconsole.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/console/kconsole.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -44,5 +44,4 @@
 #include <print.h>
 #include <panic.h>
-#include <typedefs.h>
 #include <arch/types.h>
 #include <adt/list.h>
Index: kernel/generic/src/cpu/cpu.c
===================================================================
--- kernel/generic/src/cpu/cpu.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/cpu/cpu.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -45,5 +45,4 @@
 #include <config.h>
 #include <panic.h>
-#include <typedefs.h>
 #include <memstr.h>
 #include <adt/list.h>
Index: kernel/generic/src/ddi/device.c
===================================================================
--- kernel/generic/src/ddi/device.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/ddi/device.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -39,5 +39,4 @@
 #include <atomic.h>
 #include <debug.h>
-#include <typedefs.h>
 
 static atomic_t last;
Index: kernel/generic/src/ddi/irq.c
===================================================================
--- kernel/generic/src/ddi/irq.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/ddi/irq.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -70,5 +70,4 @@
 #include <adt/hash_table.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <synch/spinlock.h>
 #include <arch.h>
Index: kernel/generic/src/debug/symtab.c
===================================================================
--- kernel/generic/src/debug/symtab.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/debug/symtab.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -37,5 +37,4 @@
 
 #include <symtab.h>
-#include <typedefs.h>
 #include <arch/byteorder.h>
 #include <func.h>
Index: kernel/generic/src/lib/elf.c
===================================================================
--- kernel/generic/src/lib/elf.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/lib/elf.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -40,5 +40,4 @@
 #include <debug.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <mm/as.h>
 #include <mm/frame.h>
Index: kernel/generic/src/lib/func.c
===================================================================
--- kernel/generic/src/lib/func.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/lib/func.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -41,5 +41,4 @@
 #include <arch/asm.h>
 #include <arch.h>
-#include <typedefs.h>
 #include <console/kconsole.h>
 
Index: kernel/generic/src/main/kinit.c
===================================================================
--- kernel/generic/src/main/kinit.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/main/kinit.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -63,4 +63,5 @@
 #include <security/cap.h>
 #include <lib/rd.h>
+#include <ipc/ipc.h>
 
 #ifdef CONFIG_SMP
Index: kernel/generic/src/main/main.c
===================================================================
--- kernel/generic/src/main/main.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/main/main.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -54,4 +54,5 @@
 #include <config.h>
 #include <time/clock.h>
+#include <time/timeout.h>
 #include <proc/scheduler.h>
 #include <proc/thread.h>
@@ -75,5 +76,4 @@
 #include <arch.h>
 #include <arch/faddr.h>
-#include <typedefs.h>
 #include <ipc/ipc.h>
 #include <macros.h>
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/mm/as.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -75,5 +75,4 @@
 #include <align.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <syscall/copy.h>
 #include <arch/interrupt.h>
@@ -169,5 +168,9 @@
 	as->refcount = 0;
 	as->cpu_refcount = 0;
+#ifdef AS_PAGE_TABLE
 	as->page_table = page_table_create(flags);
+#else
+	page_table_create(flags);
+#endif
 
 	return as;
@@ -217,5 +220,9 @@
 
 	btree_destroy(&as->as_area_btree);
+#ifdef AS_PAGE_TABLE
 	page_table_destroy(as->page_table);
+#else
+	page_table_destroy(NULL);
+#endif
 
 	interrupts_restore(ipl);
Index: kernel/generic/src/mm/backend_anon.c
===================================================================
--- kernel/generic/src/mm/backend_anon.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/mm/backend_anon.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -48,5 +48,4 @@
 #include <errno.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <align.h>
 #include <arch.h>
Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/mm/backend_elf.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -39,5 +39,4 @@
 #include <debug.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <mm/as.h>
 #include <mm/frame.h>
Index: kernel/generic/src/mm/backend_phys.c
===================================================================
--- kernel/generic/src/mm/backend_phys.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/mm/backend_phys.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -38,5 +38,4 @@
 #include <debug.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <mm/as.h>
 #include <mm/frame.h>
Index: kernel/generic/src/mm/buddy.c
===================================================================
--- kernel/generic/src/mm/buddy.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/mm/buddy.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -43,6 +43,4 @@
 #include <mm/frame.h>
 #include <arch/types.h>
-#include <typedefs.h>
-#include <adt/list.h>
 #include <debug.h>
 #include <print.h>
Index: kernel/generic/src/mm/frame.c
===================================================================
--- kernel/generic/src/mm/frame.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/mm/frame.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -52,5 +52,4 @@
  */
 
-#include <typedefs.h>
 #include <arch/types.h>
 #include <mm/frame.h>
Index: kernel/generic/src/mm/page.c
===================================================================
--- kernel/generic/src/mm/page.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/mm/page.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -47,5 +47,4 @@
 #include <mm/frame.h>
 #include <arch/types.h>
-#include <typedefs.h>
 #include <arch/asm.h>
 #include <memstr.h>
Index: kernel/generic/src/mm/tlb.c
===================================================================
--- kernel/generic/src/mm/tlb.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/mm/tlb.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -45,5 +45,4 @@
 #include <smp/ipi.h>
 #include <synch/spinlock.h>
-#include <typedefs.h>
 #include <atomic.h>
 #include <arch/interrupt.h>
@@ -52,4 +51,5 @@
 #include <panic.h>
 #include <debug.h>
+#include <cpu.h>
 
 /**
Index: kernel/generic/src/proc/scheduler.c
===================================================================
--- kernel/generic/src/proc/scheduler.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/proc/scheduler.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -45,4 +45,5 @@
 #include <mm/page.h>
 #include <mm/as.h>
+#include <time/timeout.h>
 #include <time/delay.h>
 #include <arch/asm.h>
@@ -53,9 +54,9 @@
 #include <config.h>
 #include <context.h>
+#include <fpu_context.h>
 #include <func.h>
 #include <arch.h>
 #include <adt/list.h>
 #include <panic.h>
-#include <typedefs.h>
 #include <cpu.h>
 #include <print.h>
Index: kernel/generic/src/proc/task.c
===================================================================
--- kernel/generic/src/proc/task.c	(revision 1ba41c5ae41f66c7fa3ef1caef4b77d414202fb3)
+++ kernel/generic/src/proc/task.c	(revision b3f8fb771f871e7f2bb35ce9339717639e8f86d6)
@@ -364,5 +364,5 @@
 		
 		if (sleeping)
-			waitq_interrupt_sleep(thr);
+			thread_interrupt_sleep(thr);
 	}
 	
